#include <iostream>
#include <cmath>
#include <time.h>
#include <algorithm>
#include <fstream>
#include <string>
#include <vector>
#include <sstream>
#include "Population.h"

using namespace std;

int main()
{
//parametres sur lesquels on peut influer
    //parametres generaux
    //int const nbrLoops(1000000);                      //nombre de boucles pour chaque bouble "writting"
    int const nbrWritting(200);
    double stopTime[nbrWritting];// = {100,500,1500,2000,5000,10000,15000,20000,30000,40000,50000};
    for (int l(0); l < nbrWritting; l++) stopTime[l] = double((l+1) * 20);
    double const meanNbrEntities(10000);			    //nombre d'individus en moyenne

    //parametres associes a notre espece
    /* dans ce cas, l'espece est identifiee par l'indice dans parameters[0]
     = 0 --> abeilles, donc bougent tout le temps
     = 1 --> plantes, bougent uniquement a la naissance */


    double range(0.1);

    vector<double> parametersbees(10);
    parametersbees[0] = 0;        //espece abeille
    parametersbees[1] = 0.05;     //parametre de mutation, variance du trait mutant
    parametersbees[2] = 0.003;     //coefficient de diffusion
    parametersbees[3] = range;    //range de competition
    parametersbees[4] = 10;       //intensite de competition
    parametersbees[5] = range;    //range interaction positive avec les plantes
    parametersbees[6] = 20;        //intensite d'interaction positive, taux max de naissance
    parametersbees[7] = 1;        //taux max de mort naturelle
    parametersbees[8] = 0;        //taux max de naissance naturelle
    parametersbees[9] = 0.05;         //range phenotypique d'interaction positive

    vector<double> parametersplants(10);
    parametersplants[0] = 1;        //espece plante
    parametersplants[1] = 0.05;     //parametre de mutation, variance du trait mutant
    parametersplants[2] = 0.02;      //dispersion a la naissance
    parametersplants[3] = range;    //range de competition
    parametersplants[4] = 10;       //intensite de competition
    parametersplants[5] = range;    //range interaction positive avec les abeilles
    parametersplants[6] = 2;        //intensite d'interaction positive, taux max de naissance
    parametersplants[7] = 1;        //taux max de mort naturelle
    parametersplants[8] = 2.1;        //taux max de naissance naturelle
    parametersplants[9] = 0.05;         //range phenotypique d'interaction positive

    //parametres a modifier en fonction de la modification des taux rateMove.cpp
    double const maxInterRatebees(parametersbees[6]/meanNbrEntities);
    double const maxInterRateplants(parametersplants[6]/meanNbrEntities);
    double const maxBirthRatebees(parametersbees[8]);
    double const maxBirthRateplants(parametersplants[8]);
    double const maxDeathRatebees(parametersbees[7]);
    double const maxDeathRateplants(parametersplants[7]);
    double const maxCompRatebees(parametersbees[4]/meanNbrEntities);
    double const maxCompRateplants(parametersplants[4]/meanNbrEntities);

//fin des parametres a modifier


//construction de l'espace geometrique
    Geometry const geometrySpace(0,1,0,1); //sans argument = [0,1] * [0,1]; 
                                           //[minPosition,maxPosition,minPhenotype,maxPhenotype]
//fin construction

//initialisation de la population
    //initialisation du premier individu abeille
    double initialPosition(0.5);
    vector<double> initialTrait(1,0.5);
    int initialNbrEntities(meanNbrEntities);
    double probaMutation(0.001);
    double timeNow(0);
    Entity initialEntitybee(initialTrait, initialPosition, timeNow,
                            geometrySpace, parametersbees, probaMutation);
    //initialisation du premier individu plant
    Entity initialEntityplant(initialTrait, initialPosition, timeNow,
                              geometrySpace, parametersplants, probaMutation);
    //creation Population avec NbrEntity d'abeilles et NbrEntity de plantes
    Population population(initialEntitybee);
    for (int l(0); l<initialNbrEntities-1; l++)
        {
        initialEntitybee.changePosition((double)l/initialNbrEntities*0.2+0.4);
        population.addEntity(initialEntitybee);
        }


    for (int m(0); m<initialNbrEntities; m++)
        {
        initialEntityplant.changePosition((double)m/initialNbrEntities*0.2+0.4);
        population.addEntity(initialEntityplant);
        }
//fin


//initialisation racine du generateur aleatoire
    srand(42);

//ecriture des temps d'arret
    string fileNameTime("indexStopTime.txt");
    ofstream fluxTime(fileNameTime.c_str());
//fin


//debut de l'algorithme
for (int j(0); j < nbrWritting; j++)
{
   //definition du nom de fichier dans lequel on va ecrire a chaque bouble
    string nameFile;
    stringstream ss;                         //sert a convertir un int en string
    ss << stopTime[j];
    nameFile = "scores/scores" + ss.str() + ".txt";
    ofstream file(nameFile.c_str());         //on met cette commande pour effacer les anciennes donnees dans les fichiers, s'il y en a!

    //ecriture du temps retenu dans le fichier indexNameTime
    fluxTime << stopTime[j] << endl;

    while (timeNow < stopTime[j])
    {
        population.oneStepTwoSpecies(timeNow, maxBirthRatebees, maxDeathRatebees, 
                                maxInterRatebees, maxCompRatebees, maxBirthRateplants, maxDeathRateplants, 
                                maxInterRateplants, maxCompRateplants);

        if (!population.isAlive())
        {
            cout << "everyone is dead" << endl;
            return 0;
        }
        //cout << population.nbrEntities() << " ";

        if (population.nbrEntities()> 1000 * meanNbrEntities)
        {
            cout << "the population size is too high" << endl;
            return 0;
        }
    }

    cout << timeNow << endl;
    population.writePopulation(nameFile, timeNow);

}


return 0;
}
